package jp.co.ois.sample.rabbitmqproducer;

import java.io.IOException;
import java.util.Date;
import java.util.stream.Collectors;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import lombok.extern.slf4j.Slf4j;

@Controller
@Slf4j
public class HogeController {

    @Autowired
    RabbitTemplate rabbitTemplate;

    @RequestMapping(value = "/")
    @ResponseBody
    public String hello() {
        log.debug("called.");
        rabbitTemplate.convertAndSend("hogeEx", "hoge", "HOGE-"+ new Date());
        return "hoge!";
    }

    @RequestMapping("/hoge")
    @ResponseBody
    public String hello(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String body = request.getReader().lines().collect(Collectors.joining("\r\n"));
        log.debug("body.length = {}", body.length());
        rabbitTemplate.convertAndSend("hogeEx", "moge", body);
        return "hoge!";
    }
}
